//
//  PSMFlippedImageView.m
//  NetScrape
//
//  Created by John Pannell on Thu Oct 03 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "PSMFlippedImageView.h"


@implementation PSMFlippedImageView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        [self setImageScaling:NSScaleToFit];
    }
    return self;
}

- (BOOL)isFlipped
{
    return YES;
}

- (void)scaleFrameBy:(float)scale
{
    NSSize imageSize = [[self image] size];
    float heightFactor, widthFactor;
    
    NSAffineTransform *at = [NSAffineTransform transform];
    if(scale == -1.0){
        // size to fit
        heightFactor = [[self superview] frame].size.height/imageSize.height;
        widthFactor = [[self superview] frame].size.width/imageSize.width;
        if(heightFactor > widthFactor){
            scale = widthFactor;
        } else {
            scale = heightFactor;
        }
    }
    
    [self setImageScaling:NSScaleToFit];
    [at scaleBy:scale];
    [self setFrameSize:[at transformSize:imageSize]];
    [self setNeedsDisplay:YES];
}

@end
